﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BryanKellyCapstone2017
{
    class AITestFunctions
    {
        public event EventHandler errorTryingToMoveRobot;
        public event EventHandler robotReachedDestination;
        public event EventHandler movingOnVisitedSpace;
        public event EventHandler DFSContinue;
        public event EventHandler DFSReverse;
        public event EventHandler enableShowVisitedRobot;
        public event EventHandler enableShowVisitedTarget;
        public event EventHandler disableShowVisitedRobot;
        public event EventHandler disableShowVisitedTarget;
        public event EventHandler eventTargetReachedDestination;
        public event EventHandler eventTargetError;

        public event EventHandler eventResetRobotVisited;

        private Stack<int> stackTargetRow;
        private Stack<int> stackTargetCol;
        //private Stack<char> stackRobotMovesFinal;
        private Stack<char> stackTargetMovesFinal;
        private Stack<int> stackTargetRequstRobotRow;
        private Stack<int> stackTargetRequestRobotColumn;
        //private Queue<char> stackRobotMovesTemp;
        private FloorMap floorMap;
        private List<string[]> stateArrayRobot;
        private List<string[]> stateArrayTarget;
        private int depthOfSearch;
        private int sleepAmount = 0;

        private bool returningRobotToState = false;

        private const string EMPTY = "0";
        private const string WALL = "1";
        private const string ROBOT = "2";
        private const string TARGET = "3";
        private const string GOAL = "G";
        private const string VISITED = "V";

        private const char NORTH = 'N';
        private const char SOUTH = 'S';
        private const char EAST = 'E';
        private const char WEST = 'W';

        private bool abort = false;
        private bool testDLS = false;

        public int SleepCount
        {
            set { sleepAmount = value; }
            get { return sleepAmount; }
        }
        public bool AbortThread
        {
            set { abort = value; if (abort == true) sendDisableShowVisitedRobot(); }
            get { return abort; }
        }

        public void depthLimiteSearchRobotTest(FloorMap tempFloorMap, int goalRow, int goalColumn)
        {   //Depth Limited Search Robot Test
            testDLS = true;
            floorMap = tempFloorMap;
            depthOfSearch = 0;
            stateArrayRobot = new List<string[]>();
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                stateArrayRobot.Add(new string[floorMap.FloorLayout[i].Length]);
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayRobot[i][j] = floorMap.FloorLayout[i][j];
                }
            }
            stateArrayRobot[goalRow][goalColumn] = GOAL;
            sendEnableShowVisitedRobot();

            for (int limit = 0; limit < floorMap.NumColumns * floorMap.NumRows; limit++)
            {
                if (abort)
                    return;

                if (progressDLSRobot(limit))
                {
                    sendEventRobotReachedDestination();
                    sendDisableShowVisitedRobot();
                    return;
                }
                else
                {
                    sendEventErrorTryingToRemoveRobot();
                    resetDLSVisitedRobot(goalRow,goalColumn);
                }

            }
            sendDisableShowVisitedRobot();
        }

        public bool depthLimitedSearchRobot( int goalRow, int goalColumn)
        {   //Depth Limited Search Robot Actual
            testDLS = false;
            depthOfSearch = 0;
            stateArrayRobot = new List<string[]>();
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                stateArrayRobot.Add(new string[floorMap.FloorLayout[i].Length]);
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayRobot[i][j] = floorMap.FloorLayout[i][j];
                }
            }
            stateArrayRobot[goalRow][goalColumn] = GOAL;
            sendEnableShowVisitedRobot();

            for (int limit = 0; limit < floorMap.NumColumns * floorMap.NumRows; limit++)
            {
                if (abort)
                    return false;

                if (progressDLSRobot(limit))
                {
                    sendEventRobotReachedDestination();
                    sendDisableShowVisitedRobot();
                    return true;
                }
                else
                {
                    sendEventErrorTryingToRemoveRobot();
                    resetDLSVisitedRobot(goalRow, goalColumn);
                }
                
            }
            sendDisableShowVisitedRobot();
            return false;
        }
        private void resetDLSVisitedRobot(int goalRow, int goalColumn)
        {
            sendEventResetRobotVisited();
            sendEnableShowVisitedRobot();
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayRobot[i][j] = floorMap.FloorLayout[i][j];
                }
            }
            stateArrayRobot[goalRow][goalColumn] = GOAL;
        }
        private void resetDLSVisitedTarget()
        {
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayTarget[i][j] = floorMap.FloorLayout[i][j];
                }
            }
        }
        private bool isDLSRobotAtGoalLocation()
        {
            if (stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] == GOAL)
                return true;
            if (testDLS)
            {
                if (stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] == "4")
                {
                    return true;
                }
            }
            return false;
        }
        private bool progressDLSRobot(int limit)
        {
            // TODO Fix the depthOfSearch. This isn't working as anticipated. 
            // Progress DF

            if (abort)
                return false;

            if (isDLSRobotAtGoalLocation()) 
                return true;

            else
            {
                if (limit < 0)
                    return false;
                stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] = VISITED;
                if (floorMap.isValidLocation(floorMap.RobotRow - 1, floorMap.RobotColumn) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow - 1, floorMap.RobotColumn))
                {
                    sendEnableShowVisitedRobot();
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotNorth(false))
                    {
                        if (progressDLSRobot(limit -1 ))
                            return true;
                        else
                        {
                            sendDisableShowVisitedRobot();
                            stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] = EMPTY;
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotSouth();
                        }
                    }
                }
                if (floorMap.isValidLocation(floorMap.RobotRow + 1, floorMap.RobotColumn) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow + 1, floorMap.RobotColumn))
                {
                    sendEnableShowVisitedRobot();
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotSouth(false))
                    {
                        if (progressDLSRobot(limit - 1))
                            return true;
                        else
                        {
                            sendDisableShowVisitedRobot();
                            stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] = EMPTY;
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotNorth();
                        }
                    }
                }
                if (floorMap.isValidLocation(floorMap.RobotRow, floorMap.RobotColumn - 1) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow, floorMap.RobotColumn - 1))
                {
                    sendEnableShowVisitedRobot();
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotWest(false))
                    {
                        if (progressDLSRobot(limit -1))
                            return true;
                        else
                        {
                            sendDisableShowVisitedRobot();
                            stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] = EMPTY;
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotEast();
                        }
                    }
                }
                
                if (floorMap.isValidLocation(floorMap.RobotRow, floorMap.RobotColumn + 1) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow, floorMap.RobotColumn + 1))
                {
                    sendEnableShowVisitedRobot();
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotEast(false))
                    {
                        if (progressDLSRobot(limit -1))
                            return true;
                        else
                        {
                            sendDisableShowVisitedRobot();
                            stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] = EMPTY;
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotWest();
                        }
                    }
                }
                return false;
            }
        }




        public void depthLimitedSearchTarget(FloorMap tempFloorMap)
        {/*NEW FUNCTION!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
            floorMap = tempFloorMap;
            stateArrayTarget = new List<string[]>();
            stackTargetMovesFinal = new Stack<char>(); //store the order of the path direction for execution. 
            stackTargetRequestRobotColumn = new Stack<int>(); //use these to store the location that the target attempts to move the robot to before a push. 
            stackTargetRequstRobotRow = new Stack<int>();
            //Use these stacks to keep track of the target blocks that are on the map. 
            stackTargetRow = new Stack<int>();
            stackTargetCol = new Stack<int>();

            for (int i = 0; i < floorMap.NumRows; i++)
            {
                stateArrayTarget.Add(new string[floorMap.FloorLayout[i].Length]);
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayTarget[i][j] = floorMap.FloorLayout[i][j];
                    if (stateArrayTarget[i][j] == "4")
                        stateArrayTarget[i][j] = GOAL;
                    if (stateArrayTarget[i][j] == TARGET)
                    {
                        stackTargetRow.Push(i);
                        stackTargetCol.Push(j);
                    }
                }
            }
            sendEnableShowVisitedTarget();
            int tempRow, tempCol;
            while (stackTargetRow.Count > 0)
            {
                if (abort)
                    return;
                tempRow = stackTargetRow.Pop();
                tempCol = stackTargetCol.Pop();
                for (int limit = 0; limit < (floorMap.NumColumns * floorMap.NumRows); limit++)
                {
                    if(abort)
                        return;
                    if (progressDLSTarget(tempRow, tempCol, limit))
                    {
                        resetTargetVisitedFlags();
                        sendEventTargetReachedDestination();
                        break;
                    }
                    else
                    {
                        sendEventTargetError();
                        resetDLSVisitedTarget();
                    }
                }
            }
            sendDisableShowVisitedTarget();

           
        }

        private bool progressDLSTarget(int targetRow, int targetColumn, int limit)
        {   //Depth Limited Search Target
            if (abort)
                return false;

            if (stateArrayTarget[targetRow][targetColumn] == GOAL)
                return true;
            else
            {
                stateArrayTarget[targetRow][targetColumn] = VISITED;
                //Move North
                if (isTargetMovableNorthSouth(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow - 1, targetColumn))
                {
                    sendEventResetRobotVisited();
                    if (depthLimitedSearchRobot(targetRow + 1, targetColumn))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotNorth())
                        {   //robot is in position, see if it cam push the target north
                            stackTargetMovesFinal.Push(NORTH);
                            stackTargetRequstRobotRow.Push(targetRow + 1);
                            stackTargetRequestRobotColumn.Push(targetColumn);
                            if (progressDLSTarget(targetRow - 1, targetColumn, limit-1))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }

                        }
                    }
                }
                //Move West
                if (isTargetMovableEastWest(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow, targetColumn - 1))
                {
                    sendEventResetRobotVisited();
                    if (depthLimitedSearchRobot(targetRow, targetColumn + 1))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotWest())
                        {   //robot is in position, see if it cam push the target West
                            stackTargetMovesFinal.Push(WEST);
                            stackTargetRequstRobotRow.Push(targetRow);
                            stackTargetRequestRobotColumn.Push(targetColumn + 1);
                            if (progressDLSTarget(targetRow, targetColumn - 1, limit - 1))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }

                        }
                    }
                }
                //Move South
                if (isTargetMovableNorthSouth(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow + 1, targetColumn))
                {
                    sendEventResetRobotVisited();
                    if (depthLimitedSearchRobot(targetRow - 1, targetColumn))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotSouth())
                        {   //robot is in position, see if it cam push the target South
                            stackTargetMovesFinal.Push(SOUTH);
                            stackTargetRequstRobotRow.Push(targetRow - 1);
                            stackTargetRequestRobotColumn.Push(targetColumn);
                            if (progressDLSTarget(targetRow + 1, targetColumn, limit - 1))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }

                        }
                    }
                }
                //Move East
                if (isTargetMovableEastWest(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow, targetColumn + 1))
                {
                    sendEventResetRobotVisited();
                    if (depthLimitedSearchRobot(targetRow, targetColumn - 1))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotEast())
                        {   //robot is in position, see if it cam push the target East
                            stackTargetMovesFinal.Push(EAST);
                            stackTargetRequstRobotRow.Push(targetRow);
                            stackTargetRequestRobotColumn.Push(targetColumn - 1);
                            if (progressDLSTarget(targetRow, targetColumn + 1, limit - 1))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }

                        }
                    }
                }


            }
            return false;
        }

        public void depthFirstSearchTarget(FloorMap tempFloorMap)
        {/*NEW FUNCTION!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
            floorMap = tempFloorMap;
            stateArrayTarget = new List<string[]>();
            stackTargetMovesFinal = new Stack<char>(); //store the order of the path direction for execution. 
            stackTargetRequestRobotColumn = new Stack<int>(); //use these to store the location that the target attempts to move the robot to before a push. 
            stackTargetRequstRobotRow = new Stack<int>();
            //Use these stacks to keep track of the target blocks that are on the map. 
            stackTargetRow = new Stack<int>();
            stackTargetCol = new Stack<int>();

            for (int i = 0; i < floorMap.NumRows; i++)
            {
                stateArrayTarget.Add(new string[floorMap.FloorLayout[i].Length]);
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayTarget[i][j] = floorMap.FloorLayout[i][j];
                    if (stateArrayTarget[i][j] == "4")
                        stateArrayTarget[i][j] = GOAL;
                    if (stateArrayTarget[i][j] == TARGET)
                    {
                        stackTargetRow.Push(i);
                        stackTargetCol.Push(j);
                    }
                }
            }
            sendEnableShowVisitedTarget();
            while (stackTargetRow.Count > 0)
            {
                if (progressDFSTarget(stackTargetRow.Pop(), stackTargetCol.Pop()))
                {
                    resetTargetVisitedFlags();
                    sendEventTargetReachedDestination();
                }
                else
                {
                    sendEventTargetError();
                }
            }
            sendDisableShowVisitedTarget();
        }
        private void resetTargetVisitedFlags()
        {
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayTarget[i][j] = floorMap.FloorLayout[i][j];
                    if (stateArrayTarget[i][j] == "4")
                        stateArrayTarget[i][j] = GOAL;
                }
            }
        }
        public bool depthFirstSearchRobot( int goalRow, int goalColumn)
        {/*NEW FUNCTION!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
            depthOfSearch = 0;
            stateArrayRobot = new List<string[]>();
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                stateArrayRobot.Add(new string[floorMap.FloorLayout[i].Length]);
                for (int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayRobot[i][j] = floorMap.FloorLayout[i][j];
                }
            }
            stateArrayRobot[goalRow][goalColumn] = GOAL;

            if(!returningRobotToState)
                sendEnableShowVisitedRobot();

            if (progressDFSRobot())
            {
                sendEventRobotReachedDestination();
                sendDisableShowVisitedRobot();
                return true;
            }
            else
            {
                sendEventErrorTryingToRemoveRobot();
                sendDisableShowVisitedRobot();
                return false;
            }
            
        }

        public void depthFirstSearchRobotTest(FloorMap  tempFloorMap,int goalRow,int goalColumn)
        {   //used to setup. I used this to test that the DFS works. It is not usable with the 
            //for pushing the target blocks. 
            floorMap = tempFloorMap;
            depthOfSearch = 0;
            stateArrayRobot = new List<string[]>();
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                stateArrayRobot.Add(new string[floorMap.FloorLayout[i].Length]);
                for(int j = 0; j < floorMap.FloorLayout[i].Length; j++)
                {
                    stateArrayRobot[i][j] = floorMap.FloorLayout[i][j];
                }
            }
            stateArrayRobot[goalRow][goalColumn] = GOAL;
            sendEnableShowVisitedRobot();
            
            if (progressDFSRobot())
                sendEventRobotReachedDestination();
            else
                sendEventErrorTryingToRemoveRobot();
            sendDisableShowVisitedRobot();
        }

        private bool progressDFSTarget(int targetRow, int targetColumn)
        {   //Depth First Search Target
            if (abort)
                return false;

            if (stateArrayTarget[targetRow][targetColumn] == GOAL)
                return true;
            else
            {
                stateArrayTarget[targetRow][targetColumn] = VISITED;
                //Move North
                if (isTargetMovableNorthSouth(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow - 1, targetColumn))
                {
                    sendEventResetRobotVisited();
                    if(depthFirstSearchRobot(targetRow+1,targetColumn))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotNorth())
                        {   //robot is in position, see if it cam push the target north
                            stackTargetMovesFinal.Push(NORTH);
                            stackTargetRequstRobotRow.Push(targetRow + 1);
                            stackTargetRequestRobotColumn.Push(targetColumn);
                            if(progressDFSTarget(targetRow - 1, targetColumn))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }
                            
                        }
                    }
                }
                //Move West
                if (isTargetMovableEastWest(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow, targetColumn-1))
                {
                    sendEventResetRobotVisited();
                    if (depthFirstSearchRobot(targetRow, targetColumn + 1))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotWest())
                        {   //robot is in position, see if it cam push the target West
                            stackTargetMovesFinal.Push(WEST);
                            stackTargetRequstRobotRow.Push(targetRow);
                            stackTargetRequestRobotColumn.Push(targetColumn + 1);
                            if (progressDFSTarget(targetRow, targetColumn - 1))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }

                        }
                    }
                }
                //Move South
                if (isTargetMovableNorthSouth(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow + 1, targetColumn))
                {
                    sendEventResetRobotVisited();
                    if (depthFirstSearchRobot(targetRow - 1, targetColumn))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotSouth())
                        {   //robot is in position, see if it cam push the target South
                            stackTargetMovesFinal.Push(SOUTH);
                            stackTargetRequstRobotRow.Push(targetRow - 1);
                            stackTargetRequestRobotColumn.Push(targetColumn);
                            if (progressDFSTarget(targetRow + 1, targetColumn))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }

                        }
                    }
                }
                //Move East
                if (isTargetMovableEastWest(targetRow, targetColumn) && isEmptyOrGoalSpaceTarget(targetRow, targetColumn+1))
                {
                    sendEventResetRobotVisited();
                    if (depthFirstSearchRobot(targetRow, targetColumn - 1))
                    {   //see if the robot can get into position
                        System.Threading.Thread.Sleep(sleepAmount);
                        if (floorMap.moveRobotEast())
                        {   //robot is in position, see if it cam push the target East
                            stackTargetMovesFinal.Push(EAST);
                            stackTargetRequstRobotRow.Push(targetRow);
                            stackTargetRequestRobotColumn.Push(targetColumn  - 1);
                            if (progressDFSTarget(targetRow, targetColumn+1))
                            {   //progress the Depth First Search for the target
                                return true;
                            }
                            else
                            {
                                stackTargetMovesFinal.Pop();
                                stackTargetRequstRobotRow.Pop();
                                stackTargetRequestRobotColumn.Pop();
                                System.Threading.Thread.Sleep(sleepAmount);
                                returnToPreviousState();
                            }

                        }
                    }
                }
                
               
            }
            return false;
        }
        private void returnToPreviousState()
        {   //This needs to be used to return the DFS target search to the previous state it was in. 
            //this will need to use the stack of robot moves minus the most previous state. 
            Stack<char> tempStackDirection = new Stack<char>();
            Stack<int> tempStackRow = new Stack<int>();
            Stack<int> tempStackColumn = new Stack<int>();

            string fileName = floorMap.GetFileName;
            while (stackTargetMovesFinal.Count > 0)
            {   //reverse the stack order so that first move is at top of stack
                tempStackDirection.Push(stackTargetMovesFinal.Pop());
                tempStackRow.Push(stackTargetRequstRobotRow.Pop());
                tempStackColumn.Push(stackTargetRequestRobotColumn.Pop());
            }
            floorMap.Open(fileName); //reset the data
            while (tempStackDirection.Count > 0)
            {
                returnRobotToPreviousState(tempStackRow.Peek(), tempStackColumn.Peek(), tempStackDirection.Peek());
                stackTargetMovesFinal.Push(tempStackDirection.Pop());
                stackTargetRequstRobotRow.Push(tempStackRow.Pop());
                stackTargetRequestRobotColumn.Push(tempStackColumn.Pop());

            }

        }
        private void returnRobotToPreviousState(int row, int column, char direction)
        {
            int tempSleepAmount = sleepAmount;
            sendDisableShowVisitedRobot();
            returningRobotToState = true;
            sleepAmount = sleepAmount/2;
            depthFirstSearchRobot(row, column);
            System.Threading.Thread.Sleep(sleepAmount);
            switch (direction)
            {
                case NORTH:
                    floorMap.moveRobotNorth();
                    break;
                case SOUTH:
                    floorMap.moveRobotSouth();
                    break;
                case EAST:
                    floorMap.moveRobotEast();
                    break;
                case WEST:
                    floorMap.moveRobotWest();
                    break;
            }
            sleepAmount = tempSleepAmount;
            returningRobotToState = false;
            sendEnableShowVisitedRobot();
        }
        private bool progressDFSRobot()
        {
            // TODO Fix the depthOfSearch. This isn't working as anticipated. 
            // Progress DF
            if (abort)
                return false;
            depthOfSearch++;
            if (depthOfSearch > (floorMap.NumRows * floorMap.NumColumns))
            {
                return false;
            }
            
            if (stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] == GOAL)
                return true;
          
            else
            {
                stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] = VISITED;
                if (floorMap.isValidLocation(floorMap.RobotRow - 1, floorMap.RobotColumn) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow - 1, floorMap.RobotColumn))
                {
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotNorth(false)) {
                        if (progressDFSRobot())
                            return true;
                        else
                        {
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotSouth();
                        }
                    }
                }
                
                if(floorMap.isValidLocation(floorMap.RobotRow, floorMap.RobotColumn-1) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow, floorMap.RobotColumn-1))
                {
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotWest(false))
                    {
                        if (progressDFSRobot())
                            return true;
                        else
                        {
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotEast();
                        }
                    }
                }
                if (floorMap.isValidLocation(floorMap.RobotRow + 1, floorMap.RobotColumn) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow + 1, floorMap.RobotColumn))
                {
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotSouth(false))
                    {
                        if (progressDFSRobot())
                            return true;
                        else
                        {
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotNorth();
                        }
                    }
                }                
                if (floorMap.isValidLocation(floorMap.RobotRow, floorMap.RobotColumn+1) && isEmptyOrGoalSpaceRobot(floorMap.RobotRow, floorMap.RobotColumn+1))
                {
                    System.Threading.Thread.Sleep(sleepAmount);
                    if (floorMap.moveRobotEast(false))
                    {
                        if (progressDFSRobot())
                            return true;
                        else
                        {
                            System.Threading.Thread.Sleep(sleepAmount);
                            floorMap.moveRobotWest();
                        }
                    }
                }
                return false;
            }
        }
        private bool isTargetMovableNorthSouth(int targetRow, int targetCol)
        {
            if (!floorMap.isValidLocation(targetRow + 1, targetCol) || !floorMap.isValidLocation(targetRow - 1, targetCol))
                return false;
            if (stateArrayTarget[targetRow + 1][targetCol] == WALL)
                return false;
            if (stateArrayTarget[targetRow - 1][targetCol] == WALL)
                return false;

            return true;
        }
        private bool isTargetMovableEastWest(int targetRow, int targetCol)
        {
            if (!floorMap.isValidLocation(targetRow, targetCol + 1) || !floorMap.isValidLocation(targetRow, targetCol - 1))
                return false;
            if (stateArrayTarget[targetRow][targetCol + 1] == WALL)
                return false;
            if (stateArrayTarget[targetRow][targetCol - 1] == WALL)
                return false;

            return true;
        }
        private bool isEmptyOrGoalSpaceRobot(int row,int col)
        {
            return (stateArrayRobot[row][col] == EMPTY || stateArrayRobot[row][col] == GOAL || stateArrayRobot[row][col] == "4");
        }
        private bool isEmptyOrGoalSpaceTarget(int row, int col)
        {
            return (stateArrayTarget[row][col] == EMPTY || stateArrayTarget[row][col] == GOAL) || stateArrayTarget[row][col] == ROBOT;
        }


        public void moveRobotToGoal(FloorMap tempFloorMap,int goalRow, int goalColumn)
        { /*This is just a test function. I used it to test if I could get communication between FloorMap.cs 
            AITestFunctions.cs and the Main.cs. This helped me realize I needed to use threading.*/
            
            floorMap = tempFloorMap;
            int row,column;
            while (!isRobotAtGoal(goalRow,goalColumn))
            {
                System.Threading.Thread.Sleep(sleepAmount);
                row = floorMap.RobotRow;
                column = floorMap.RobotColumn;
                if (row < 0 || column < 0)
                    return;

                if (goalRow == row)
                {   //already at goal row, now move closer to goal column
                    if (!moveRobotToCloserColumn(goalColumn))
                    {
                        sendEventErrorTryingToRemoveRobot();
                        return;
                    }
                }
                else if(goalColumn == column)
                {   //already at goal column, now move closer to goal row
                    if (!moveRobotToCloserRow(goalRow))
                    {
                        sendEventErrorTryingToRemoveRobot();
                        return;
                    }
                }
                else
                {   //not at either goal row or goal column, find which is closer
                    if (Math.Abs(goalRow - floorMap.RobotRow) < Math.Abs(goalColumn - floorMap.RobotColumn))
                    {   //closer to goal row than goal column
                        if (!moveRobotToCloserRow(goalRow))
                        { //If it can't move up or down try left or right
                            if (!moveRobotToCloserColumn(goalColumn))
                            {
                                sendEventErrorTryingToRemoveRobot();
                                return;
                            }
                        }
                    }
                    else
                    {
                        if (!moveRobotToCloserColumn(goalColumn))
                        {   //if it can't move left or right try up or down
                            if (!moveRobotToCloserRow(goalRow))
                            {
                                sendEventErrorTryingToRemoveRobot();
                                return;
                            }
                                    
                        }
                    }
                }
            }
            sendEventRobotReachedDestination();
        }
        private void sendEventResetRobotVisited()
        {
            if (this.eventResetRobotVisited != null)
                this.eventResetRobotVisited(this, EventArgs.Empty);
        }
        private void sendDisableShowVisitedRobot()
        {
            if (this.disableShowVisitedRobot != null)
                this.disableShowVisitedRobot(this, EventArgs.Empty);
        }
        private void sendDisableShowVisitedTarget()
        {
            if (this.disableShowVisitedTarget != null)
                this.disableShowVisitedTarget(this, EventArgs.Empty);
        }
        private void sendEventTargetReachedDestination()
        {
            if (this.eventTargetReachedDestination != null)
                this.eventTargetReachedDestination(this, EventArgs.Empty);
        }
        private void sendEventTargetError()
        {
            if (this.eventTargetError != null)
                this.eventTargetError(this, EventArgs.Empty);
        }
        private void sendEnableShowVisitedTarget()
        {
            if (this.enableShowVisitedTarget != null)
                this.enableShowVisitedTarget(this, EventArgs.Empty);
        }
        private void sendEnableShowVisitedRobot()
        {
            if (this.enableShowVisitedRobot != null)
                this.enableShowVisitedRobot(this, EventArgs.Empty);
        }
        private void sendVisitedMessage()
        {
            if (this.movingOnVisitedSpace != null)
                this.movingOnVisitedSpace(this, EventArgs.Empty);
        }
        private void sendDFSContinueMessage()
        {
            if (this.DFSContinue != null)
                this.DFSContinue(this, EventArgs.Empty);
        }
        private void sendDFSReverse()
        {
            if (this.DFSReverse != null)
                this.DFSReverse(this, EventArgs.Empty);
        }
        private void sendEventErrorTryingToRemoveRobot()
        {
            if (this.errorTryingToMoveRobot != null)
                this.errorTryingToMoveRobot(this, EventArgs.Empty);
        }
        private void sendEventRobotReachedDestination()
        {
            if (this.robotReachedDestination != null)
                this.robotReachedDestination(this, EventArgs.Empty);
        }
        private bool moveRobotToCloserRow(int goalRow)
        {
            if ((goalRow - floorMap.RobotRow) > 0)
            {
                if (floorMap.moveRobotSouth())
                    return true;
                else
                    return false;
            }
            else
            {
                if (floorMap.moveRobotNorth())
                    return true;
                else
                    return false;
            }
                
        }
        private bool moveRobotToCloserColumn(int goalColumn)
        {
            if ((goalColumn - floorMap.RobotColumn) > 0)
            {
                if (floorMap.moveRobotEast())
                    return true;
                else
                    return false;
            }
            else
            {
                if (floorMap.moveRobotWest())
                    return true;
                else
                    return false;
            }
        }
        private bool isRobotAtGoal(int goalRow, int goalColumn)
        {
            return (floorMap.RobotRow == goalRow && floorMap.RobotColumn == goalColumn);
        }
    }
}
